hasOwnProperty бросает ReferenceError

verfaa

Профессор
Регистрация
29 Янв 2007
Сообщения
412
Реакции
48
С помощью fetch делаю GET запрос:
Код:
    fetch("/?mode=ajax&action=gen")
          .then(response => response.json())
          .then(data => {
   
               console.log(data);
               console.log(typeof data);
   
               if ( ! data.hasOwnProperty(added_logs)) {
                   throw new Error("Нет логов: поля 'added_logs' в результирующем наборе не найдено!");
               }
   
               })
          .catch(err => {
                $('#ajax_err span').html(err);
                $('#ajax_err').show();
          })
    ;
data имеет вид:

Код:
{result: "ok", added_logs: Array(24), added_count: 24}

и выводит в консоль object
Но вот участок кода:
Код:
       if ( ! data.hasOwnProperty(added_logs)) {
           throw new Error("Нет логов: поля 'added_logs' в результирующем наборе не найдено!");
       }
бросает ошибку:
Код:
    ReferenceError: added_logs is not defined
Не могу понять почему? Ведь свойство added_logs есть в объекте data
Так проверять неправильно?
 

Sorcus

Sorcus. A New Beginning.
Регистрация
10 Июл 2011
Сообщения
513
Реакции
884
С помощью fetch делаю GET запрос:
Код:
    fetch("/?mode=ajax&action=gen")
          .then(response => response.json())
          .then(data => {
  
               console.log(data);
               console.log(typeof data);
  
               if ( ! data.hasOwnProperty(added_logs)) {
                   throw new Error("Нет логов: поля 'added_logs' в результирующем наборе не найдено!");
               }
  
               })
          .catch(err => {
                $('#ajax_err span').html(err);
                $('#ajax_err').show();
          })
    ;
data имеет вид:

Код:
{result: "ok", added_logs: Array(24), added_count: 24}

и выводит в консоль object
Но вот участок кода:
Код:
       if ( ! data.hasOwnProperty(added_logs)) {
           throw new Error("Нет логов: поля 'added_logs' в результирующем наборе не найдено!");
       }
бросает ошибку:
Код:
    ReferenceError: added_logs is not defined
Не могу понять почему? Ведь свойство added_logs есть в объекте data
Так проверять неправильно?
Для просмотра ссылки Войди или Зарегистрируйся
Засунь added_logs в кавычки и заработает.
 
Сверху